# developer Marketing Cloud Personalization (personalization) - Full Documentation # Account Export API The Marketing Cloud Personalization Account Export API helps you retrieve account-level data from datasets such as segments, engagement scores, change in engagement scores, and customer activity for use in other systems. Your Personalization contract defines the volume of records you can export using the Account Export API. For more information, refer to your contract or contact your account representative. **important:** Account Profiles was retired in August 2024. For more information, see [Personalization Account Profiles Retirement](https://help.salesforce.com/s/articleView?id=001744617&type=1). ## Exporting Account Data via API Export account data from a Personalization dataset. ### Method and Endpoint `GET` `/api/dataset//accounts.< json | csv >` ### Request URL `https://..evergage.com/api/dataset//accounts.< json | csv >` ### Request Parameters | URL Parameter | Required? | Description | | ---------------- | --------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | `accountName` | Yes | The Personalization account name. You can find the `accountName` by accessing **Gears** from the Personalization UI and reviewing the URL. For example, if the Gears URL is `https://demo.us-1.evergage.com/`, then the account name is `demo`. | | `instance` | Yes | The Personalization instance identifier. You can find this value by accessing **Gears** from the Personalization UI and reviewing the URL. For example, if the Gears URL is `https://demo.us-1.evergage.com/`, then the instance identifier is `us-1`. | | `datasetId` | Yes | The name or identifier of the Personalization dataset you’re exporting account data from. | | `filter` | No | Optional Segment name or ID | | `start` | No | Optional start time in epoch milliseconds used for engagement statistics | | `end` | No | Optional end time in epoch milliseconds used for engagement statistics | | `segmentationId` | No | Optional segmentation identifier | | `segmentId` | No | Optional segment identifier | | `pageSize` | No | Number of records to return. Returns all records unless specified. | | `page` | No | Page number of records to show, starting at zero for the first page. Starts at zero unless specified. | ### Authorization `Authorization: Basic ` The Account Export API uses API tokens to authenticate requests. Your API token must be a strict Base64 encoding of your API Key ID and its API Secret Key, separated by a colon. You can use an existing API token if it has the required permissions. Alternatively, you can ask an account administrator to generate a new one from the Personalization UI. For more information on API tokens, see [Personalization API Tokens](https://help.salesforce.com/s/articleView?id=sf.mc_pers_api_tokens.htm) on Salesforce Help. Alternatively, if you use [cURL](https://curl.se/docs/manpage.html) to interact with the API, you can send your API Key ID and its API Key Secret using the `-u "apiKeyId:apiKeySecret"` command-line option. cURL automatically converts the `apiKeyId:apiKeySecret` pair into a Base64-encoded string and adds the `Authorization: Basic ` to the request header. For an example of how to pass your API credentials in a cURL request, refer to the [Example](#example) section in this article. ### Example The following is an example GET request sent using cURL that retrieves account data in the JSON format from the specified Personalization dataset. **note:** The following example request passes API credentials using the `-u` command-line option. ```bash curl -u "apiKeyId:apiKeySecret" \ "https://..evergage.com/api/dataset//accounts.json" ``` The preceding example cURL request generates the following example response in the JSON format. ```json [ { "name": "Acme, Inc.", "engagementScore": 0.546, "engagementPercentChange": -0.138, "firstActivity": 1358640000000, "lastActivity": 1360195200000, "totalActions": 51, "accountStatus": "premium", "attributes": {}, "accountName": "Acme, Inc.", "activeUsers": 3, "segments": [] } ] ``` ## See Also - _Salesforce Help_: [Personalization API Tokens](https://help.salesforce.com/s/articleView?id=sf.mc_pers_api_tokens.htm) # Add Third Party Tracking Parameters to Open Time Email Campaigns Urchin Tracking Module (UTM) parameters are tags that you can add to the end of a URL to track its performance and know its traffic sources. Adding UTM parameters to URLs in your Open Time Email Campaigns can give you more detailed insights into your campaign's performance. While Marketing Cloud Personalization provides analytics and full campaign performance reporting, you can still use your existing web analytics system to monitor clickthrough traffic with your Open Time Email campaigns. To learn more about how you can combine third-party tracking data with data from Personalization, talk to your Salesforce account representative. This article describes how to use UTM parameters with Open Time Email Campaigns. To know more about Open Time Email Campaigns, or how to create one, see [Open Time Email Campaigns](https://help.salesforce.com/s/articleView?id=sf.mc_pers_email_campaign.htm) on Salesforce Help. Before reading the instructions in this article, make sure you've created or cloned an Open Time Email campaign, tested it, and have its HTML code open in front of you. ## Add UTM Parameters to Your Emails To add UTM parameters to your emails, do the following. 1. Access the Open Time Email campaign within the Campaign Edit screen in the Personalization UI. For detailed instructions on accessing the Campaign Edit screen, see [Create an Open Time Email Campaign](https://help.salesforce.com/s/articleView?id=sf.mc_pers_email_campaign_create.htm) on Salesforce Help. 2. Click **SIMULATE** > **Show HTML**. 3. Identify the URLs to track in your email campaign. We recommend tracking URLs for item recommendations included in your email template along with any other URLs of importance. 4. Append UTM parameters at the end of each identified URL, starting with and separated by the `&` symbol. Excluding the `&` symbol breaks the URL and leads to improper tracking. For example, if the URL of an item in your email is `https://demo.evergage.com/api/dataset/engage/campaign/YnFdJ/N7pF1/1/detail?userId=@@USER_ID@@`, add the UTM parameters at the end of the URL as shown in the following example. ``` https://demo.evergage.com/api/dataset/engage/campaign/YnFdJ/N7pF1/1/detail?userId=%40%40USER_ID&utm_source=newsletter&utm_medium=email&utm_campaign=lead_generation ``` After you've added UTM parameters to all relevant URLs, use the updated campaign HTML with your email marketing solution to send your campaign to recipients. With the UTM parameters you added, you can track your campaign's clickthrough rates directly in your web analytics system. ## URL Encoding in UTM Parameters To ensure that URLs resolve correctly, you must encode all non-ASCII characters and the following reserved ASCII characters when using them in UTM parameters. | ASCII Character | URL Encoding | | --------------- | ------------ | | `!` | `%21` | | `#` | `%23` | | `$` | `%24` | | `'` | `%27` | | `(` | `%28` | | `)` | `%29` | | `*` | `%2A` | | `+` | `%2B` | | `,` | `%2C` | | `/` | `%2F` | | `:` | `%3A` | | `;` | `%3B` | | `=` | `%3D` | | `?` | `%3F` | | `@` | `%40` | | `[` | `%5B` | | `\|` | `%5C` | | `]` | `%5D` | ## Example The following code sample contains HTML for a row of three item recommendations in an Open Time Email campaign. This sample HTML is for illustrative purposes only and includes an illustrative dynamic variable `@@USER_ID@@` for `userId`. Your email marketing solution could use a different dynamic variable format. **note:** Depending on your email marketing solution, you may have to modify the item and item image URLs in your Open Time Email campaign. For more information on capturing and modifying campaign URLs, refer to [Capture an Open Time Email Campaign URL](https://developer.salesforce.com/docs/marketing/personalization/guide/capture-email-campaign-url.md). ```html
``` The goal of this example is to track the traffic source of item URLs in the campaign. To do so, we'll append the UTM parameters `utm_source=newsletter`, `utm_medium=email`, and `utm_campaign=lead_generation` at the end of each item URL, after `detail?userId=@@USER_ID@@"`. The sample campaign HTML after adding UTM parameters to each item URL is as shown in the following example. ```html
``` ## See Also - _Salesforce Help_: [Open Time Email Campaigns](https://help.salesforce.com/s/articleView?id=sf.mc_pers_email_campaign.htm) - _Salesforce Help_: [Create an Open Time Email Campaign](https://help.salesforce.com/s/articleView?id=sf.mc_pers_email_campaign_create.htm) # Additional APIs Marketing Cloud Personalization provides the following additional APIs that let you interact with and retrieve data from your Personalization instance, and also perform housekeeping tasks on your Personalization instance as needed. - [Account Export API](https://developer.salesforce.com/docs/marketing/personalization/guide/account-export-api.md) - Export account data from Personalization datasets. - [Audit Log API](https://developer.salesforce.com/docs/marketing/personalization/guide/audit-log-api.md) - Retrieve access and activity logs from your Personalization instance. - [Principals API](https://developer.salesforce.com/docs/marketing/personalization/guide/principals-api.md) - Retrieve list of Personalization Principals. - [User Export API](https://developer.salesforce.com/docs/marketing/personalization/guide/user-export-api.md) - Export user data from Personalization datasets. - [User Look-Up & Deletion API](https://developer.salesforce.com/docs/marketing/personalization/guide/user-look-up-deletion-api.md) - Service _Right to Access_ and _Right to be Forgotten_ requests received from customers. # Advanced Dynamic Content Cheatsheet This section details the variables used for advanced dynamic messages. ## Users | Variable | Type | Description | | -------------------------------- | ------ | ------------------------------- | | `${user.id}` | String | User ID | | `${user.userName}` | String | Name | | `${user.userNameOrAnonLocation}` | String | Name or "user from City, State" | | `${user.accountType}` | String | Account type | | `${user.emailAddress}` | String | Email address | ### User Location | Variable | Type | Description | | ------------------------------------ | ------- | -------------------------------------------------- | | `${user.location.postalCode}` | String | ZIP code | | `${user.location.city}` | String | City | | `${user.location.metro}` | String | Metro area | | `${user.location.metroCode}` | Integer | Metro code | | `${user.location.region}` | String | State/region | | `${user.location.stateProvinceCode}` | String | State/region code (shorthand) | | `${user.location.country}` | String | Country | | `${user.location.countryCode}` | String | Country code (shorthand) | | `${user.location.organization}` | String | Organization | | `${user.location.industry}` | String | Industry | | `${user.location.naicsCode}` | Integer | North American Industry Classification System code | ### User Custom | Variable | Description | | ------------------------------ | --------------------------------------------------------- | | `${user.attributes._________}` | Custom Attribute (Use dropdown in editor for specific ID) | ## Items Things that count as items: - Products - Articles - Blogs - Catalog Objects - Categories ### Basic Must have intended item query selected in message settings | Variable | Type | Description | | --------------------------------- | ----------------- | ------------------------------------------------------ | | `${item}` | Object | Item object | | `${items}` | Array | Array of item objects | | `${items[0]}...${items[9]}` | Object | Item in array | | `${page.item}` | Object | Current page item object | | `${page.category}` | Object | Current page category or category of current page item | | `${item.name}` | String | Item name | | `${item.id}` | String or Integer | Item ID | | `${item.url}` | String | Item URL | | `${item.imageUrl}` | String | Image URL | | `${item.description}` | String | Item description | | `#field(${item.rating}, '0')` | Integer | Average rating | | `#field(${item.numRatings}, '0')` | Integer | Number of ratings | | `${item.categories}` | Array | Categories objects | | `${item.dimensions}` | Array | All related Catalog Objects | | Custom Variables | Description | | -------------------------------- | ------------------------------------------------ | | `${item.attributes.xxxxx.value}` | Value of the attribute named "xxxxx" on the item | ### Products Only | Variable | Type | Description | | -------------------------- | ------- | ------------------------------------------------------------------------------------- | | `${item.price}` | Integer | Price. **NOTE**: Unformatted. For more information, see [Utilities](#utilities). | | `${item.priceDescription}` | String | Price description | | `${item.listPrice}` | Float | List price. **NOTE**: Unformatted. For more information, see [Utilities](#utilities). | | `${item.inventoryCount}` | Integer | Inventory count | | `${item.brands}` | Array | Brand tag objects | | `${item.classes}` | Array | Class tag objects | | `${item.styles}` | Array | Style tag objects | | `${item.genders}` | Array | Gender tag objects | ## Build Item Query in Message (Advanced) ### Query Type: Global/User Interchangeable | Variable | Description | | ------------------------------- | ----------------------- | | `${tools.global...}` | Query Global Statistics | | `${tools.user...}` | Query User Statistics | | `${tools.global.products...}` | Query Products | | `${tools.global.articles...}` | Query Articles | | `${tools.global.blogs...}` | Query Blogs | | `${tools.global.categories...}` | Query Categories | | `${tools.global.brands...}` | Query Brands | | `${tools.global.styles...}` | Query Styles | | `${tools.global.authors...}` | Query Authors | | `${tools.global.keywords...}` | Query Keywords | ### Query: Default Array Length Min 1 Max 5 | Variable | Type | Description | | ------------------------------------------ | ----- | --------------------------------------- | | `${tools.global.products.viewCount()}` | Array | Top viewed products by count | | `${tools.global.products.viewTime()}` | Array | Top viewed products by time | | `${tools.global.products.cartCount()}` | Array | Products most added to cart by count | | `${tools.global.products.cartValue()}` | Array | Products most added to cart by currency | | `${tools.global.products.purchaseCount()}` | Array | Top purchased products by count | Ensure that you either iterate over every product in an array ### Global Only | Variable | Type | Description | | ------------------------------------------ | ----- | ------------------------------- | | `${tools.global.products.publishedDate()}` | Array | Most recently published product | ### User Only | Variable | Type | Description | | ----------------------------------------- | ----- | ---------------------------------------------------------------------------------- | | `${tools.user.products.viewed()}` | Array | Most Recently Viewed | | `${tools.user.orders.currentItems()}` | Array | Products in cart. **Note**: Personalization doesn’t currently track cart removals. | | `${tools.user.orders.currentValue()}` | Float | Total cart value. **Note**: Unformatted, see utilities. | | `${tools.user.get('Engagement', 'none')}` | | User's Engagement Score | ## Item Options You can further refine results from query functions by passing them a set of item options, as shown in the following example. ```html $tools.user.products.viewCount(${itemOptions...}) ``` You can specify item options by calling multiple functions on the `itemOptions` object, as shown in the following example. ```html ${itemOptions.optionOne().optionTwo().optionThree()} ``` ### Sizes By default, a message containing advanced dynamic queries renders only if there's at least 1 result. To increase the minimum number of items returned, use `${itemOptions.minItems()}`. To increase the maximum number of items returned, use `${itemOptions.maxItems()}`. **note:** You can’t increase the maximum number of items returned beyond 10. ### Filters You can further filter query results using the following filters. | Filter | Description | | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------- | | `${itemOptions.withCategory()}` | Filter results by the category the visitor is currently viewing. | | `${itemOptions.withBrand()}` | Filter results to contain only items with a specific brand. | | `${itemOptions.withBrandAnyOf([,,...])}` | Filter results to contain items from any of the specified brands. | | `${itemOptions.withGender()}` | Filter results by gender. | | `${itemOptions.withGenderAnyOf([,,...])}` | Filter results by any of the specified gender IDs. | | `${itemOptions.withKeyword(,,...])}` | Filter results by any of the specified keywords. | | `${itemOptions.withAuthor(,,...)}` | Filter results by any of the specified authors. | | `${itemOptions.withContentClass()}` | Filter results by `ContentClassID`. | | `${itemOptions.withContentClassAnyOf([,,...])}` | Filter results by any of the specified content classes. | | `${itemOptions.withStyle()}` | Filter results by style. | | `${itemOptions.withStyleAnyOf([,,...])}` | Filter results by any of the specified styles. | | `${itemOptions.withItemClass()}` | Filter results by item class. | | `${itemOptions.withItemClassAnyOf([,,...])}` | Filter results by any of the specified item classes. | | `${itemOptions.whereCreated()}` | Filter results by date or time range of creation. To know more about the available `TimeObject` functions, see [Lookback Period](#lookback-period). | | `${itemOptions.wherePublished()}` | Filter results by published or time range. To know more about the available `TimeObject` functions, see [Lookback Period](#lookback-period). | ### Lookback Period To specify a lookback period apart from the default lookback period of the past week, use: ```handlebars ${itemOptions.time()} ``` The following functions are provided by the `$time` singleton object: | Function | Description | | -------------- | -------------------------------------------------------------------------------- | | `today` | Today | | `thisWeek` | Current calendar week (with Monday as first day of week) | | `thisMonth` | Current calendar month | | `since(date)` | Since the specified date; date format is “mm/dd/yyyy” (for example “07/07/2017”) | | `lastNDays(n)` | Last n days, including today; lastNDays(1) would mean today and yesterday | | `allTime` | Don’t define a specific date range | ### Conditional Options The `itemOptions` object provides several conditional options or methods that you can call to filter or manipulate its properties based on certain conditions. | Conditional Option | Description | | ------------------------------------------- | -------------------------------------------- | | `${itemOptions.whereName()...}` | Filter data based on item name. | | `${itemOptions.whereDescription()...}` | Filter data based on item description. | | `${itemOptions.whereUrl()...}` | Filter data based on item URL. | | `${itemOptions.whereImageUrl()...}` | Filter data based on an item's image URL. | | `${itemOptions.wherePriceDescription()...}` | Filter data based on item price description. | #### Conditionals You can use conditionals with conditional options to further refine the data being filtered. ```handlebars ${itemOptions.whereName().exists()} ``` The following conditionals are available for use. | Conditional | Description | | -------------------------- | -------------------------------------------------------------------------------- | | `exists()` | Checks whether the property being filtered exists. | | `doesNotExist()` | Checks whether the property being filtered doesn’t exist. | | `contains()` | Checks whether the property being filtered contains the specified string. | | `doesNotContain()` | Checks whether the property being filtered doesn’t contain the specified string. | ### Sorting To sort the results for display, use the `displaySort` function. ```handlebars ${itemOptions.displaySort()} ``` To sort results for display in the descending order, use the `descending` function. ```handlebars ${itemOptions.descending()} ``` The `displaySort` function provides the following sort options. | Sort Option | Description | | -------------------------------- | -------------------------------- | | `${productSort.name()}` | Sort products by name. | | `${productSort.price()}` | Sort products by price. | | `${articleSort.name()}` | Sort articles by name. | | `${articleSort.publishedDate()}` | Sort articles by published date. | | `${blogSort.name()}` | Sort blogs by name. | | `${blogSort.publishedDate()}` | Sort blogs by published date. | To sort results for display in the descending order, use the `descending` function. ```handlebars ${itemOptions.descending()} ``` ### Inclusions To include items a visitor is currently viewing in query results, use: ```handlebars ${itemOptions.includeItemsBeingViewed()} ``` To include items in a visitor's cart in query results, use: ```handlebars ${itemOptions.includeItemsInCart()} ``` ### Exclusions To exclude items a visitor has already purchased from query results, use: ```handlebars ${itemOptions.excludePurchasedItems()} ``` To exclude items a visitor has already viewed from query results, use: ```handlebars ${itemOptions.excludeViewedItems()} ``` ## Utilities ### If/Else Statements ```html
Hello $user.attributes.firstName
You don't have a first name at all
``` ### Set Variables ```handlebars #set (${variableName} = $...) ``` ### Loops ```handlebars #foreach (${variableName} in ) ... #end ``` ### Format Price There are two ways to format prices. - By passing the price as a floating-point number to the `formatPrice` method. The `formatPrice` method formats the given number as a price, with the default dataset currency symbol and appropriate decimal formatting, and returns the formatted string. ```handlebars $tools.formatPrice() ``` **important:** In Open Time Email Templates, only the `$currencyTools.formatPrice()` method is available. This method is used instead of is used instead of the `$tools.formatPrice()` and `$tools.formatNumber(, )` methods. - By passing the price as a floating-point number and a fixed number of digits after the decimal point to the `formatNumber` method. ```handlebars $tools.formatNumber(, ) ``` ### Field The `#field` utility enables you to provide a fallback value for an attribute. ```html
#field($item.attributes.testString, "Item does not have a testString attribute")
``` # Advanced Dynamic Message Content Reference Dynamic Message Content (DMC) allows you to insert personalized content into your Marketing Cloud Personalization Open Time Email and Mobile Data campaign messages in real time. When you enable and use DMC, you can insert placeholders into a message that are replaced with the corresponding values for the receiving audience. However, there are cases where DMC placeholders aren’t configurable enough to cater to specific or advanced requirements. In such cases, you can use Advanced Dynamic Message Content (ADMC) syntax to gain greater flexibility and control over the dynamic message content. ADMC offers variables for additional configurability so you can address specific or complex campaign requirements. You can use ADMC to query Personalization to return a specific set of items or content that matches certain criteria, and to further refine your query results. Overall, ADMC helps create engaging messages for campaign audiences, whether providing product recommendations, promoting related content, or offering targeted promotions. **important:** We suggest enlisting the help of experienced developers while using ADMC in your campaigns. If you’re unsure of any requirements or need further assistance with Advanced Dynamic Message Content, [create a support case](https://help.salesforce.com/s/articleView?language=en_US&id=sf.workcom_contact_support.htm&type=5&_ga=2.21226995.990954368.1679247489-1261322914.1674192271). To know more about using ADMC in your campaigns, see [Use Advanced Dynamic Message Content](https://developer.salesforce.com/docs/marketing/personalization/guide/use-advanced-dynamic-message-content.md). ## See Also - [Advanced Dynamic Message Content Cheatsheet](https://developer.salesforce.com/docs/marketing/personalization/guide/advanced-dynamic-message-content-cheatsheet.md) - _Salesforce Help_: [Dynamic Message Content](https://help.salesforce.com/s/articleView?id=sf.mc_pers_mobile_campaign_dynamic_message_content.htm) - _Salesforce Help_: [Open Time Email Campaigns](https://help.salesforce.com/s/articleView?id=sf.mc_pers_email_campaign.htm) # Advanced Use-Case APIs - [Marketing Cloud Personalization Trends](https://developer.salesforce.com/docs/marketing/personalization/guide/advanced-use-case-apis/is-trends.md) - [Web Surveys](https://developer.salesforce.com/docs/marketing/personalization/guide/advanced-use-case-apis/web-surveys.md) # Arrays Certain properties can be declared as an array, allowing the input to be multi-select. Doing so returns all selected values within an array. | Property Type | Supported As Array | | -------------- | ------------------ | | boolean | No | | string | Yes | | number | Yes | | Color | No | | Complex Object | Yes | | Select | Yes | | Typed List | No | --- ## Simple Types Simple types can be put into multi-value arrays by simply making them arrays. ```typescript names: string[]; ``` ![Array Input](https://developer.salesforce.com/media/interface-template-configuration/ArrayInput.png) String literal types can also be used as multi-value to provide the end user with a set of options of which multiple can be selected. ```typescript names: ("Alpha"|"Beta"|"Gamma"|"Delta")[]; ``` ![Array Select](https://developer.salesforce.com/media/interface-template-configuration/ArraySelect.png) --- ## Arrays of Complex Objects Configurations can also be arrays of complex objects. You can use these arrays to permit the user to create a list of configured objects. When used in combination with the `@tabular` decorator, it is possible to create table structured inputs. ```typescript export class LTVBands { label: string; minimumLtv: number; } export class LifecyclesLifecycle implements GearLifecycle { @tabular() valueBands: LTVBands[]; } ``` ![Array Complex](https://developer.salesforce.com/media/interface-template-configuration/ArrayComplex.png) # Attributes Attributes are custom-configured, type-safe fields that can store additional custom data at various levels in the platform. You can configure attributes for users, accounts, catalog objects, and profile objects. ## Supported Value Types The following table details the value types supported by Attributes. | Value Type | Description | | ---------- | ------------------------------------------------------------------------------------------------------------------------------------------------- | | String | Text information | | Integer | Whole numbers | | Decimal | Floating point numbers | | Date | Date and time, specifically the JavaScript [`Date`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date) object | | Boolean | `true` or `false` | | null | Attribute present but without an object value | ## Details Attribute collections are keyed off the attribute name/id, as depicted in the following example. ```typescript attributes: { [attributeName: string]: Attribute }; ``` Each `Attribute` contains a `value` and optional `metadata` about the value. ```typescript interface Attribute { readonly value: AttributeValue; readonly metadata?: Readonly; } ``` A value can be of type `string`, `number`, `boolean`, `null`, `Date`, or a (potentially nested) collection containing them. ```typescript type AttributeValue = string | number | boolean | Date | null | AttributeValueArray; interface AttributeValueArray extends ReadonlyArray {} ``` The optional `metadata` can contain detailed information about the value, as depicted in the following example. ```typescript /** * Source: https://github.com/usnistgov/NISTIR-8112/ * * Glossary: * * Attribute Provider (AP) Manages and provides assertions of identity attributes to other relying and federated * parties. * * Relying Party (RP) An entity that relies upon a subject’s authenticator(s) and credentials or an IDP's assertion of a * subject’s identity, typically to process a transaction or to grant access to information or a system. In this case, * the RP is the Personalization app. */ interface ValueMetadata { /** * The name of the entity that issues or creates the initial attribute value. * * The Origin element conveys the name of the entity that established the initial attribute value. This may or * may not be an authoritative entity, or the provider; if, for example, the AP generates the attribute value * through a derivation process, then the AP would be the origin. The key distinction between the origin and the * provider is the act of initially generating, capturing, or provisioning the attribute's value, rather than * just asserting the attribute's value to an RP. * * e.g. CRM, PointOfSaleSystem, FulfillmentSystem, or LoyaltySystem */ origin?: string; /** * The name of the entity that is providing the attribute. * * This specifies the name of the entity that supplies the attribute value to the RP. This does not have to be * the AP itself. This element enables RPs to understand and evaluate the source of the individual attribute * values that may be included in a bundle of attributes. For example, if a full service credential provider * generates an assertion with several identity attributes provided by multiple APs, the {@code provider} * element enables the RP to understand, at a granular level, where each has come from and determine whether or * not that value can be used for access to specific resources. In instances where a single attribute is * asserted directly to the RP, this element may be omitted since the assertion itself will carry the provider * information as well as a certificate or digital signature. * * e.g. CsvUserEtlJob:user-20190528.csv.gz */ provider?: string; /** * the ID of the Personalization gear that updated the attribute, or null if it was not updated by a gear */ gearId?: string; /** * The date and time when the attribute value was last updated */ lastUpdated?: Date; /** * The date and time when the attribute value was last verified as being true and belonging to the specified * individual */ lastVerified?: Date; /** * Metadata relevant or pertaining to the security classification of a given attribute's value */ classification?: Classification; } type Classification = "Sensitive" | "PersonallyIdentifiable" | "NonSensitive"; ``` **important:** The `publishedDate` attribute must be exclusively used for articles and blogs. For other use cases, create a new custom attribute. ## Immutability Attribute TypeScript declarations can almost always contain a `read-only` modifier. Attribute collections are mutable, which means you can add, replace, and remove attributes. However, each attribute is immutable after it is created, ensuring that an attribute value and its optional associated metadata remain in sync. This immutability also means that you must define a value and its optional associated metadata together. Currently, you cannot replace or remove an entire collection of attributes. Instead, you can mutate the existing collection. ## Example Usages ### Creating Attributes ```typescript function mutatingUserAttributes(user: User): void { // Removing delete user.attributes.nameToDelete; delete user.attributes["bracketStyle"]; // Adding user.attributes.someString = { value: "hi" }; user.attributes["someInt"] = { value: 123, metadata: { lastUpdated: new Date(), classification: "NonSensitive" }, }; user.attributes.someDecimal = { value: 123.45 }; user.attributes["someDate"] = { value: new Date(322376400000) }; user.attributes.someBool = { value: false }; user.attributes.someArray = { value: ["one", 2, null, new Date()] }; // Building up complex array to add val = []; val.push("Abigail"); val.push({ cell: "555-1234" }); val.push([2, 4, 6]); val.push({ a: ["b"], c: { d: ["e", ["f"]] } }); val.push([{ one: 2, three: { four: [5, [6, 7]] } }, [8, { nine: 10 }]]); meta = {}; meta.origin = "someOrigin"; meta.lastUpdated = new Date(); user.attributes.complexArray = { value: val, metadata: meta }; } ``` ### Reading Attributes ```typescript // Not fully safe examples: function readingUserAttributeValuesUnsafely(user: User): void { // Assuming attribute present and correct value type, simply casting: let str: string = user.attributes.someString.value as string; // Checking attribute present, then assuming correct value type and casting. // Using undefined to represent not-present: let num: number | undefined = !user.attributes.someNum ? undefined : (user.attributes.someNum.value as number); } // Fully safe examples: function readingUserAttributeValuesSafely(user: User): void { // Handling all cases: if (!user.attributes.someString) { // Attribute not present } else if (user.attributes.someString.value === null) { // Attribute value null } else if (typeof user.attributes.someString.value !== "string") { // Attribute value not a string } else { const str: string = user.attributes.someString.value as string; } // Checking attribute present and value type. // Using undefined to represent not-present or undesired-type: let bool: boolean | undefined = user.attributes.someBool && typeof user.attributes.someBool.value === "boolean" ? (user.attributes.someBool.value as boolean) : undefined; // Similar but as an if statement: if (user.attributes.someBool && typeof user.attributes.someBool.value === "boolean") { const bool: boolean = user.attributes.someBool.value as boolean; } // Similar but using guard functions: if (user.attributes.someBool && isBoolean(user.attributes.someBool.value)) { const bool: boolean = user.attributes.someBool.value; } if (user.attributes.someDate && isDate(user.attributes.someDate.value)) { const date: Date = user.attributes.someDate.value; } if (user.attributes.complexArray && isArray(user.attributes.complexArray.value)) { const arr: AttributeValueArray = user.attributes.complexArray.value; if (arr.length > 0 && isNumber(arr[0])) { const num: number = arr[0] as number; } } } // Guard functions: // Currently the platform may provide a Date-like proxy, with getTime() etc. So avoid `instanceof`. function isDate(value: AttributeValue): value is Date { return typeof value === "object" && typeof (value as Date).getTime === "function"; } function isArray(value: AttributeValue): value is AttributeValueArray { return Array.isArray(value); } function isBoolean(value: AttributeValue): value is boolean { return typeof value === "boolean"; } function isString(value: AttributeValue): value is string { return typeof value === "string"; } function isNumber(value: AttributeValue): value is number { return typeof value === "number"; } function isNull(value: AttributeValue): value is null { return value === null; } ``` # Audit Log API The Marketing Cloud Personalization Audit Log API enables you to programmatically retrieve access and activity logs from your Personalization instance. You can use the Audit Log API to retrieve logs for specific date ranges up to 50 days in the past. This API provides paginated responses with up to 2000 records per page. Each log record includes information about authentication, API token and user management, campaigns, templates, catalog configurations, segments, and other related events. You can use these logs for security and investigation purposes, and to demonstrate compliance with laws, regulations, and policies. In addition, using a specified timeframe, the API enables you to export audit trail information into your internal systems for easy storage, search, and analysis. ## Method and Endpoint `GET` `/api/audit/list` ## Request URL `https://..evergage.com/api/audit/list` ### URL Parameters | URL Parameter | Required? | Description | | ------------- | --------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `accountName` | Yes | The Personalization account name. You can find the `accountName` by accessing **Gears** from the Personalization UI and reviewing the URL. For example, if the Gears URL is `https://demo.us-1.evergage.com/`, then the account name is `demo`. | | `instance` | Yes | The Personalization instance identifier. You can find this value by accessing **Gears** from the Personalization UI and reviewing the URL. For example, if the Gears URL is `https://demo.us-1.evergage.com/`, then the instance identifier is `us-1`. | | `page` | No | The specific page of data to return from a paginated response. The `page` parameter is typically used in conjunction with the `pageSize` parameter to control the number of records returned per page. The default value is `1`. To iterate through an entire response, start by setting page to `1`, and continue making requests until you get zero results. | | `pageSize` | No | The number of records to be returned per page in a paginated response. The `pageSize` parameter is typically used in conjunction with the `page` parameter to navigate through a paginated response. The default value is `100`. | | `startDate` | No | The start date of the date range for the audit logs to be returned. If unspecified, the default value is seven days before the current date. The `startDate` must precede the `endDate` and be sent as a string represented in the ISO-8601 format, for example, `2023-03-01T22:00:00.000Z`. | | `endDate` | No | The end date of the audit log date range that you want to retrieve. If unspecified, the default value is the current date. The `endDate` value must follow the `startDate` value, and be sent as a string represented in the ISO-8601 format, for example,`2023-03-01T22:00:00.000Z`. **Note**: You can retrieve logs for a maximum range of 50 days. If the range specified exceeds 50 days, the platform automatically adjusts the range and outputs logs from 50 days before the specified `endDate`. | ## Response Content Type - `application/json` ## Authorization `Authorization: Basic ` The Audit Log API uses API tokens to authenticate requests. Your API token must be a strict Base64 encoding of your API Key ID and its API Secret Key, separated by a colon. For the API token to have access to the Audit Log API, you must enable the **Can access Audit logs** permission when creating or updating a token. For security purposes, we recommend using a dedicated token to access Audit Log API with only this permission enabled. **important:** A token with the **Can access Audit logs** permission doesn’t use dataset restrictions for the Audit Log data. Instead, the token provides access to Audit Log data across all datasets. For more information on API tokens, see [Personalization API Tokens](https://help.salesforce.com/s/articleView?id=sf.mc_pers_api_tokens.htm) on Salesforce Help. When using [cURL](https://curl.se/docs/manpage.html) to interact with the API, you can use the `-u "apiKeyId:apiKeySecret"` command-line option to send your API Key ID and API Key Secret. cURL automatically converts the `apiKeyId:apiKeySecret` pair into a Base64-encoded string and adds `Authorization: Basic ` to the request header. ## Example Request The following is an example API request sent using cURL. ```bash curl -H 'Content-Type: application/json' \ -u ":" \ "https://..evergage.com/api/audit/list?page=1&pageSize=50&startDate=2023-03-01T00:00:00.000Z&endDate=2023-03-10T00:00:00.000Z" ``` ## Example Response ```json { "page": 1, "pageSize": 9, "count": 706, "startDate": "2023-03-10T00:00:00.000Z", "endDate": "2023-03-23T00:00:00.000Z" "items": [ { "date": "2023-03-22T13:01:54.451Z", "tenantId": "my_tenant_id", "employee": { "ipAddress": "2.2.2.2" }, "type": "Authentication", "operation": { "name": "Auth", "detail": [ "LoginSuccess" ] }, "object": { "id": "test@salesforce.com" } }, { "date": "2023-03-22T12:01:52.917Z", "tenantId": "my_tenant_id", "datasetId": "my_dataset_id", "employee": { "id": "test@salesforce.com", "emailAddress": "test@salesforce.com" }, "type": "Campaign Template", "operation": { "name": "Update", "detail": [ "draft-serverSideTypeScript" ] }, "object": { "id": "TFz6G" } }, { "date": "2023-03-22T11:46:28.255Z", "tenantId": "my_tenant_id", "datasetId": "my_dataset_id", "employee": { "id": "test@salesforce.com", "emailAddress": "test@salesforce.com" }, "type": "Campaign Template", "operation": { "name": "Create" }, "object": { "id": "TFz6G" } }, { "date": "2023-03-22T11:12:30.821Z", "tenantId": "my_tenant_id", "datasetId": "my_dataset_id", "employee": { "id": "test@salesforce.com", "emailAddress": "test@salesforce.com" }, "type": "Segment", "operation": { "name": "Update" }, "object": { "id": "EBljH" } }, { "date": "2023-03-22T11:12:04.440Z", "tenantId": "my_tenant_id", "datasetId": "my_dataset_id", "employee": { "id": "test@salesforce.com", "emailAddress": "test@salesforce.com" }, "type": "Segment", "operation": { "name": "Create" }, "object": { "id": "EBljH" } }, { "date": "2023-03-22T11:09:57.150Z", "tenantId": "my_tenant_id", "datasetId": "my_dataset_id", "employee": { "id": "test@salesforce.com", "emailAddress": "test@salesforce.com" }, "type": "Segment", "operation": { "name": "Update" }, "object": { "id": "1zDIZ" } } ] } ``` | Property | Optional | Data Type | Description | | ------------------------------ | -------- | --------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | `page` | No | Number | The requested page number. The value of the `page` query parameter you specified in the request, or the default value if no page number was specified. | | `pageSize` | No | Number | The requested page size. The value of the `pageSize` query parameter you specified in the request, or the default value if no page number was specified. | | `count` | No | Number | Number of records for the specified date range. | | `startDate` | No | String | The start date in the ISO-8601 format used when filtering the results. For example: `2023-03-01T22:00:00.000Z`. | | `endDate` | No | String | The end date in the ISO-8601 format used when filtering the results. For example: `2023-03-01T22:00:00.000Z`. | | `items` | No | Array | An array of Audit Log events. | | `.date` | No | String | The event date for a record in the ISO-8601 format. For example: 2023-03-01T22:00:00.000Z.A string representation of the event date in the ISO-8601 format. For example: `2023-03-01T22:00:00.000Z`. | | `.tenantId` | No | String | Your Personalization `accountName`. | | `.datasetId` | Yes | String | The dataset where an event occurred. This property doesn’t exist for global events like authentication. | | `.employee.ipAddress` | Yes | String | The IP address of the user associated with the audit event, if available. | | `.employee.id` | Yes | String | The Marketing Cloud user ID associated with the audit event, if available. | | `.employee.emailAddress` | Yes | String | The Marketing Cloud user email address associated with the audit event, if available. | | `.type` | No | String | Audit Log event type. For example: `API Token`, `Authentication`, `Segment`, `Campaign`, and so on. | | `.operation.name` | No | String | The type of operation performed. Examples of available options: `Create`, `Read`, `Update`, `Delete`, `Auth`, `Execute`, `TestExecute`. | | `.operation.detail` | Yes | Array | A list of optional additional details about the operation performed by the user. | | `.object.id` | Yes | String | A reference to the object that was affected by the logged operation. | ## See Also - _Salesforce Help_: [View the Personalization Audit Log](https://help.salesforce.com/s/articleView?id=sf.mc_pers_audit_log_viewing.htm) - _Salesforce Help_: [Personalization API Tokens](https://help.salesforce.com/s/articleView?language=en_US&id=sf.mc_pers_api_tokens.htm) # B2B Using [Tableau](https://www.tableau.com) as our "client", the following document describes and presents code for an example implementation. The sample code in this document is not exhaustive and maps only key areas of the site that are valuable for demonstration purposes. The primary focus is depicting how to approach designing a Catalog for B2B websites. While each implementation is unique, this sitemap contends with many issues, particularly mapping B2B sites and websites without purchasable products in general. **important:** The sitemap code examples in this article are only for demonstration purposes. Avoid copying sample code into your Sitemap Editor as it is built around example scenarios that can differ from your implementation's goals and use cases. ## Client Requirements This section outlines the functionality that our imaginary client requires from their implementation. Since each client or customer always has a unique set of requirements and use cases in mind for Marketing Cloud Personalization, experience is the real teacher when it comes to knowing what questions to ask clients to help them establish their goals and requirements for their use of Personalization. ### Primary Goal - Understand the content a user is most interested in based on their prior interactions with the site. ### Home page type - Recommend Blogs similar to recently viewed Blogs, fallback to promote trending Blogs. ### Solutions, Learning, and Product Landing page types - Recommend Articles of the same Category (solutions, learn, or products) as the currently viewed landing page. - Personalize banner based on past interest in Articles under the currently viewed Category ### Solutions, Learning, and Product page types - Capture `Industry`, `JobRole`, `PageBundle`, and `Department` values as related catalog objects. ### Product page type - Capture `Keyword` values as a related catalog object. - Recommend related product Articles by `Keyword`. - Distinguish between `Add-On` and `Software` products in the Catalog. ### Blog Landing page type - Recommend trending `Blogs`. ### Blog page type - Recommend related `Blog` posts based on category. ## Discovery - Since it is the only identity consistently available on the web and used as a username when users log in to the site, `emailAddress` is used as the default Web SDK identity attribute used for this implementation. The site already uses email addresses to identify its users, so we are configuring Personalization to piggyback on that identity attribute. > _**Aside**: Since an email address is Personally Identifiable Information (PII), make sure you have the appropriate approval from within your organization before using it as a Personalization Identity. Additionally, using emails captured from web forms, other than a login form, as an Identity could potentially cause privacy issues where more than one user is tied to a Personalization user. In the following code, email is only being captured from the login form when a user successfully logs in. The code capturing user id is designed to work on [Tableau Public](https://public.tableau.com/) as this portion of the Tableau site is accessible by everyone with a free public account. For more information on Identity, read [Identity System Setup for the Web SDK](https://help.salesforce.com/s/articleView?id=sf.mc_pers_identity_web_sdk.htm)._ - While this site does promote products, there is no ability to purchase products or attribute revenue to them from other channels, matching with user activity from the web. Since we do not need the special capabilities of the `Product` item type for this implementation, we are instead using the `Article` item type, using `Category` to tell types of `Article` items apart. > _**Aside**: If the website had a more robust, hierarchical category system in which it could be possible to share `Category` information between the `Article` types, we would instead configure a catalog object specifically to house the type of `Article`, such as `ArticleType`. This way, if solutions and products shared `Category` data, they would be relatable to each other, instead of belonging to siloed `Category` hierarchies, each starting with their respective `Article` type (solutions, products, and learning)._ - There is a categorization system already natively built into the site's blog section, so our code scrapes the categories already present in the `dataLayer` as `Category` in the Personalization Catalog. Collecting `Category` data for the `Blogs` help build user affinity based on those categories. These categories are used to also power the customer's use case to recommend related `Blogs` on blog pages based on the currently viewed `Category`. - In addition to `Category` data, the `dataLayer` contains other useful information, such as `Department` and `Job Role`. The values for `Department` and `Job Role` are collected as `relatedCatalogObjects` to tie them to each of the collected `Article` types. As these values are collected, they are used to build a user's affinity towards them, which can then be used for segmentation and potentially for recommending `Articles` of any `Category` based on one of these related catalog objects, instead of only recommending `Articles` of one type at a time. - To distinguish between `Add-On` and `Software` products in the Catalog, as stated in the "Client Requirements", we are mapping a related catalog object called `ProductType` on the "product" page type. Remember, we are using the `Article` item type to house Catalog data for the `product`, `solutions`, and `learning` page types. As a result, our `ProductType` catalog object is attached to the `Article` Catalog item type when configuring the Catalog, even though it is mapped only on one page type containing `Article` Catalog data. The `ProductType` related catalog object helps to more granularly distinguish which type of product `Article` is being viewed by the user and create highly targeted recipes based on that activity, if desired. **note:** The following examples assume that `emailAddress` has been configured as the default Web SDK Identity. ## Example Sitemap in the SalesforceInteractions Namespace ```javascript SalesforceInteractions.init({ cookieDomain: "tableau.com", consents: [ { purpose: SalesforceInteractions.mcis.ConsentPurpose.Personalization, provider: "Example Consent Manager", status: SalesforceInteractions.ConsentStatus.OptIn, }, ], }).then(() => { const findInDataLayer = (targetAttribute) => { if (!window.dataLayer) { return; } for (let i = 0; i < window.dataLayer.length; i++) { const result = SalesforceInteractions.mcis.getValueFromNestedObject( "window.dataLayer[" + i + "]", ); if (result && result[targetAttribute]) { return result; } } return; }; // We set a value for this variable only once per page load and then reference it several times for the data found in the dataLayer needed for each page. let pageDetails; const setPageDetailsFromDataLayer = () => { pageDetails = pageDetails || findInDataLayer("entityId"); }; /* Here we will first check session storage for the islogin item containing the user's email that is associated with their account. This value is set in the global event listener in the site config when a submission event occurs. On this website, both successful and invalid form submissions emit a submission event, the page also is quickly reloaded after a successful login. In this unusual situation, we will first save the submitted data in session storage. Then when the page loads, we check for the islogin value in session storage and then look for a DOM element which indicates a successful login before retrieving the stored user email and sending our login event. */ let loginEvent = sessionStorage.getItem("islogin"); // if there is a stored login event... if (loginEvent) { // wait for the logged in user dropdown to appear in the nav, signifying a successful login SalesforceInteractions.DisplayUtils.pageElementLoaded( "#block-public-sitewide-ui-author-profile-dropdown", ).then(() => { // remove the stored email from session storage sessionStorage.removeItem("islogin"); // construct and send the Login Success event to Personalization SalesforceInteractions.sendEvent({ interaction: { name: "Login Success" }, user: { /* The users email address provided in the login form is sent to Personalization as user.identities.emailAddress because in this example, emailAddress is configured to be the default identity for the web channel. */ identities: { emailAddress: loginEvent, }, }, }); }); } const config = { global: { contentZones: [ { name: "global_popup" }, { name: "global_infobar" }, { name: "global_exit_intent" }, /* Since the website does not have consistent selectors and structure within the Article pages, this content zone will be used to add recs to the bottom of Article pages. */ { name: "global_footer", selector: "footer.global-footer" }, ], listeners: [ /* Here we are listening for all submission events that happen within this document. This pattern can be used to create generic form submission event handlers, or even just to consolidate them to one place in the sitemap code. */ SalesforceInteractions.listener("submit", "body", (event) => { // Check the id of the event target to check for the login form we want to scrape data from if (event.target.id === "login-form") { // loop through login form fields... for (i = 0; i < event.target.length; i++) { // Find the email field by id within the event object. if (event.target[i].id === "login-email") { // save user email in session storage sessionStorage.setItem("islogin", event.target[i].value); } } } }), ], }, pageTypeDefault: { name: "default", interaction: { name: "Default Page", }, }, pageTypes: [ { name: "home", isMatch: () => /^\/$/.test(window.location.pathname), interaction: { name: "Homepage", }, contentZones: [ { name: "home_recs_1", selector: "section.datalocation-audience-segment-links" }, { name: "home_recs_2", selector: "section.datalocation-customer-stories" }, ], }, { name: "products_landing", isMatch: () => /^\/products\/?$/.test(window.location.pathname), interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { /* Remember, Catalog IDs are case sensitive. Transforming collected values as all upper case or all lower case is a common method for ensuring consistency throughout the site when creating Catalog IDs with the sitemap which do not need to correspond to data in external systems. */ type: "Category", id: () => SalesforceInteractions.mcis .getLastPathComponentWithoutExtension(window.location.pathname) .toLowerCase(), attributes: { url: SalesforceInteractions.resolvers.fromCanonical(), name: SalesforceInteractions.resolvers.fromMeta("og:title"), }, }, }, contentZones: [{ name: "products_landing_hero_banner", selector: "#hero" }], }, { name: "solutions_landing", isMatch: () => /^\/solutions\/?(customers|industries|departments|technologies)?$/.test( window.location.pathname, ), interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { /* The last parameter of each resolver function accepts a function which returns whatever the desired final value is. This is very useful when you need to transform or sanitize a scraped value before sending it to Interaction studio. You can learn more about resolver functions here: https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-implementation.html#resolvers Below, the pathname portion of the URL is transformed into a hierarchal Category id. */ type: "Category", id: SalesforceInteractions.resolvers.fromWindow("location.pathname", (path) => path.split("/").slice(1).join("|").toLowerCase(), ), attributes: { url: SalesforceInteractions.resolvers.fromCanonical(), name: SalesforceInteractions.resolvers.fromMeta("og:title"), }, }, }, contentZones: [{ name: "solutions_landing_hero_banner", selector: "#hero" }], }, { name: "learning_landing", isMatch: () => /^\/learn\/?$/.test(window.location.pathname), interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { type: "Category", id: () => SalesforceInteractions.mcis .getLastPathComponentWithoutExtension(window.location.pathname) .toLowerCase(), attributes: { url: SalesforceInteractions.resolvers.fromCanonical(), name: SalesforceInteractions.resolvers.fromMeta("og:title"), }, }, }, contentZones: [ { name: "learning_landing_gray_recs", selector: ".entity-paragraphs-item.paragraph--type--cross-reference", }, { name: "learning_landing_hero_banner", selector: "#hero" }, ], }, { name: "blog_landing", isMatch: () => /^\/about\/blog\/?$/.test(window.location.pathname), interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { type: "Category", id: () => SalesforceInteractions.mcis .getLastPathComponentWithoutExtension(window.location.pathname) .toLowerCase(), attributes: { url: SalesforceInteractions.resolvers.fromCanonical(), name: SalesforceInteractions.resolvers.fromMeta("og:title"), }, }, }, contentZones: [ { name: "blog_landing_card_wall", selector: ".card-wall" }, { name: "blog_landing_hero_banner", selector: "#hero" }, ], }, { name: "product", action: "Product", isMatch: () => { if (/^\/products\//.test(window.location.pathname)) { /* We only want to call setPageDetailsFromDataLayer() when pages which rely on scraping information from the dataLayer are actually matched. Adding a conditional statement prevents this function from being called on every page on the site as Personalization resolves every isMatch function to see which page type matches the current one. */ setPageDetailsFromDataLayer(); return true; } return false; }, interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { /* Remember, while this site does promote products, there is no ability to purchase products or attribute revenue to them from other channels which would match with user activity from the web. Since the special capabilities of the Product item type will not be needed for this implementation, we will instead use the Article item type, utilizing Category to tell types of Article apart. */ type: "Article", /* We are using SalesforceInteractions.mcis.getValueFromNestedObject() to more easily reference data from the pageDetails object after the value is set when the page matches. */ id: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityId", pageDetails), attributes: { name: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityLabel", pageDetails), url: SalesforceInteractions.resolvers.fromCanonical(), imageUrl: SalesforceInteractions.resolvers.fromSelectorAttribute( "div.feature-highlight__image img", "src", ), }, relatedCatalogObjects: { Category: SalesforceInteractions.resolvers.fromWindow("location.pathname", (path) => { const categories = path.split("/").slice(1); categories.pop(); if (categories.length === 0) { const dataLayerCategories = SalesforceInteractions.mcis.getValueFromNestedObject( "page.category1", pageDetails, ); return dataLayerCategories ? [dataLayerCategories.toLowerCase()] : []; } return [categories.join("|").toLowerCase()]; }), ProductType: () => window.location.pathname.indexOf("add-ons") > -1 ? ["Add-On"] : ["Software"], Industry: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.field_dmo_industries", pageDetails, ) || null, Department: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.field_departments", pageDetails, ) || null, JobRole: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.taxonomy_vocabulary_23", pageDetails, ) || null, PageBundle: () => { const pageBundle = SalesforceInteractions.mcis.getValueFromNestedObject( "entityBundleNice", pageDetails, ); return pageBundle ? [pageBundle] : null; }, Keyword: SalesforceInteractions.resolvers.fromMeta("keywords", (ele) => { return ele ? ele.split(/\,\s*/) : null; }), }, }, }, listeners: [ SalesforceInteractions.listener( "submit", "#webform-submission-email-embeddable-1-add-form", (event) => { SalesforceInteractions.sendEvent({ interaction: { name: "Free Trial Download" }, /* A content zone is provided in this event in order to allow a campaign targeting the "global_infobar" content zone to be returned in the response sent back from Personalization with this request. */ source: { contentZones: ["global_infobar"], }, }); }, ), ], }, { name: "solutions", isMatch: () => { if ( /\/solutions\/(?!customers|industries|departments|technologies)/.test( window.location.pathname, ) ) { setPageDetailsFromDataLayer(); return true; } return false; }, interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { type: "Article", id: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityId", pageDetails), attributes: { name: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityLabel", pageDetails), url: SalesforceInteractions.resolvers.fromCanonical(), imageUrl: SalesforceInteractions.resolvers.fromSelectorAttribute( "div.feature-highlight__image img", "src", ), }, relatedCatalogObjects: { Category: SalesforceInteractions.resolvers.fromWindow("location.pathname", (path) => { const categories = path.split("/").slice(1); categories.pop(); return [categories.join("|").toLowerCase()]; }), Industry: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.field_dmo_industries", pageDetails, ) || null, Department: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.field_departments", pageDetails, ) || null, JobRole: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.taxonomy_vocabulary_23", pageDetails, ) || null, PageBundle: () => { const pageBundle = SalesforceInteractions.mcis.getValueFromNestedObject( "entityBundleNice", pageDetails, ); return pageBundle ? [pageBundle] : null; }, }, }, }, }, { name: "learning", isMatch: () => { if (/^\/learn\//.test(window.location.pathname)) { setPageDetailsFromDataLayer(); return true; } return false; }, interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { type: "Article", id: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityId", pageDetails), attributes: { name: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityLabel", pageDetails), url: SalesforceInteractions.resolvers.fromCanonical(), imageUrl: SalesforceInteractions.resolvers.fromSelectorAttribute( "div.feature-highlight__image img", "src", ), }, relatedCatalogObjects: { Category: SalesforceInteractions.resolvers.fromWindow("location.pathname", (path) => { const categories = path.split("/").slice(1); categories.pop(); return [categories.join("|").toLowerCase()]; }), Industry: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.field_dmo_industries", pageDetails, ) || null, Department: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.field_departments", pageDetails, ) || null, JobRole: () => SalesforceInteractions.mcis.getValueFromNestedObject( "dataModelFields.taxonomy_vocabulary_23", pageDetails, ) || null, PageBundle: () => { const pageBundle = SalesforceInteractions.mcis.getValueFromNestedObject( "entityBundleNice", pageDetails, ); return pageBundle ? [pageBundle] : null; }, }, }, }, }, { name: "blog", isMatch: () => { if (/\/about\/blog\/\d+\/\d+\/.+/.test(window.location.pathname)) { setPageDetailsFromDataLayer(); return true; } return false; }, interaction: { name: SalesforceInteractions.CatalogObjectInteractionName.ViewCatalogObject, catalogObject: { type: "Blog", id: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityId", pageDetails), attributes: { name: () => SalesforceInteractions.mcis.getValueFromNestedObject("entityLabel", pageDetails), url: SalesforceInteractions.resolvers.fromCanonical(), imageUrl: SalesforceInteractions.resolvers.fromMeta("og:image"), }, relatedCatalogObjects: { Category: () => [ SalesforceInteractions.mcis.getValueFromNestedObject( "flatTaxonomy.blog_categories", pageDetails, ), ], }, }, }, listeners: [ SalesforceInteractions.listener("submit", ".premium-access-ajax", () => { const eloquaId = findInDataLayer("EloquaGuid"); if (eloquaId) { SalesforceInteractions.sendEvent({ interaction: { name: "Tableau Blog Sign-up" }, user: { attributes: { eloquaId: eloquaId } }, }); } }), ], contentZones: [ /* As in this case below, content zones do not necessarily have to denote content to be replaced, they can be useful for inserting template content before or after the the DOM node with the provided selector. */ { name: "blog_text_content", selector: ".field--name-field-page-sections" }, ], }, ], }; SalesforceInteractions.initSitemap(config); }); ``` ## Example Sitemap in the Evergage Namespace ```javascript Evergage.init({ cookieDomain: "tableau.com", }).then(() => { const findInDataLayer = (targetAttribute) => { if (!window.dataLayer) { return; } for (let i = 0; i < window.dataLayer.length; i++) { const result = Evergage.util.getValueFromNestedObject("window.dataLayer[" + i + "]"); if (result && result[targetAttribute]) { return result; } } return; }; // We set a value for this variable only once per page load and then reference it several times for the data found in the dataLayer needed for each page. let pageDetails; const setPageDetailsFromDataLayer = () => { pageDetails = pageDetails || findInDataLayer("entityId"); }; /* Here we will first check session storage for the islogin item containing the user's email that is associated with their account. This value is set in the global event listener in the site config when a submission event occurs. On this website, both successful and invalid form submissions emit a submission event, the page also is quickly reloaded after a successful login. In this unusual situation, we will first save the submitted data in session storage. Then when the page loads, we check for the islogin value in session storage and then look for a DOM element which indicates a successful login before retrieving the stored user email and sending our login event. */ let loginEvent = sessionStorage.getItem("islogin"); // if there is a stored login event... if (loginEvent) { // wait for the logged in user dropdown to appear in the nav, signifying a successful login Evergage.DisplayUtils.pageElementLoaded( "#block-public-sitewide-ui-author-profile-dropdown", ).then(() => { // remove the stored email from session storage sessionStorage.removeItem("islogin"); // construct and send the Login Success event to Personalization Evergage.sendEvent({ action: "Login Success", user: { /* The users email address provided in the login form is sent to Personalization as user.id because in this example, emailAddress is configured to be the default identity for the web channel. */ id: loginEvent, }, }); }); } const config = { global: { contentZones: [ { name: "global_popup" }, { name: "global_infobar" }, { name: "global_exit_intent" }, /* Since the website does not have consistent selectors and structure within the Article pages, this content zone will be used to add recs to the bottom of Article pages. */ { name: "global_footer", selector: "footer.global-footer" }, ], listeners: [ /* Here we are listening for all submission events that happen within this document. This pattern can be used to create generic form submission event handlers, or even just to consolidate them to one place in the sitemap code. */ Evergage.listener("submit", document, (event) => { // Check the id of the event target to check for the login form we want to scrape data from if (event.target.id === "login-form") { // loop through login form fields... for (i = 0; i < event.target.length; i++) { // Find the email field by id within the event object. if (event.target[i].id === "login-email") { // save user email in session storage sessionStorage.setItem("islogin", event.target[i].value); } } } }), ], }, pageTypeDefault: { name: "default", }, pageTypes: [ { name: "home", action: "Homepage", isMatch: () => /^\/$/.test(window.location.pathname), contentZones: [ { name: "home_recs_1", selector: "section.datalocation-audience-segment-links" }, { name: "home_recs_2", selector: "section.datalocation-customer-stories" }, ], }, { name: "products_landing", action: "Products Landing", isMatch: () => /^\/products\/?$/.test(window.location.pathname), catalog: { Category: { /* Remember, Catalog IDs are case sensitive. Transforming collected values as all upper case or all lower case is a common method for ensuring consistency throughout the site when creating Catalog IDs with the sitemap which do not need to correspond to data in external systems. */ _id: () => Evergage.util .getLastPathComponentWithoutExtension(window.location.pathname) .toLowerCase(), url: Evergage.resolvers.fromCanonical(), name: Evergage.resolvers.fromMeta("og:title"), }, }, contentZones: [{ name: "products_landing_hero_banner", selector: "#hero" }], }, { name: "solutions_landing", action: "Solutions Landing", isMatch: () => /^\/solutions\/?(customers|industries|departments|technologies)?$/.test( window.location.pathname, ), catalog: { Category: { /* The last parameter of each resolver function accepts a function which returns whatever the desired final value is. This is very useful when you need to transform or sanitize a scraped value before sending it to Interaction studio. You can learn more about resolver functions here: https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-implementation.html#resolvers Below, the pathname portion of the URL is transformed into a hierarchal Category id. */ _id: Evergage.resolvers.fromWindow("location.pathname", (path) => path.split("/").slice(1).join("|").toLowerCase(), ), url: Evergage.resolvers.fromCanonical(), name: Evergage.resolvers.fromMeta("og:title"), }, }, contentZones: [{ name: "solutions_landing_hero_banner", selector: "#hero" }], }, { name: "learning_landing", action: "Learning Landing", isMatch: () => /^\/learn\/?$/.test(window.location.pathname), catalog: { Category: { _id: () => Evergage.util .getLastPathComponentWithoutExtension(window.location.pathname) .toLowerCase(), url: Evergage.resolvers.fromCanonical(), name: Evergage.resolvers.fromMeta("og:title"), }, }, contentZones: [ { name: "learning_landing_gray_recs", selector: ".entity-paragraphs-item.paragraph--type--cross-reference", }, { name: "learning_landing_hero_banner", selector: "#hero" }, ], }, { name: "blog_landing", action: "Blog Landing", isMatch: () => /^\/about\/blog\/?$/.test(window.location.pathname), catalog: { Category: { _id: () => Evergage.util .getLastPathComponentWithoutExtension(window.location.pathname) .toLowerCase(), url: Evergage.resolvers.fromCanonical(), name: Evergage.resolvers.fromMeta("og:title"), }, }, contentZones: [ { name: "blog_landing_card_wall", selector: ".card-wall" }, { name: "blog_landing_hero_banner", selector: "#hero" }, ], }, { name: "product", action: "Product", isMatch: () => { if (/^\/products\//.test(window.location.pathname)) { /* We only want to call setPageDetailsFromDataLayer() when pages which rely on scraping information from the dataLayer are actually matched. Adding a conditional statement prevents this function from being called on every page on the site as Personalization resolves every isMatch function to see which page type matches the current one. */ setPageDetailsFromDataLayer(); return true; } return false; }, catalog: { /* Remember, while this site does promote products, there is no ability to purchase products or attribute revenue to them from other channels which would match with user activity from the web. Since the special capabilities of the Product item type will not be needed for this implementation, we will instead use the Article item type, utilizing Category to tell types of Article apart. */ Article: { /* We are using Evergage.util.getValueFromNestedObject() to more easily reference data from the pageDetails object after the value is set when the page matches. */ _id: () => Evergage.util.getValueFromNestedObject("entityId", pageDetails), name: () => Evergage.util.getValueFromNestedObject("entityLabel", pageDetails), url: Evergage.resolvers.fromCanonical(), imageUrl: Evergage.resolvers.fromSelectorAttribute( "div.feature-highlight__image img", "src", ), categories: Evergage.resolvers.fromWindow("location.pathname", (path) => { const categories = path.split("/").slice(1); categories.pop(); if (categories.length === 0) { const dataLayerCategories = Evergage.util.getValueFromNestedObject( "page.category1", pageDetails, ); return dataLayerCategories ? [dataLayerCategories.toLowerCase()] : []; } return [categories.join("|").toLowerCase()]; }), relatedCatalogObjects: { // In case you're using 'dimensions' instead of 'relatedCatalogObjects', you can continue to do so as they both function the same way. ProductType: () => window.location.pathname.indexOf("add-ons") > -1 ? ["Add-On"] : ["Software"], Industry: () => Evergage.util.getValueFromNestedObject( "dataModelFields.field_dmo_industries", pageDetails, ) || null, Department: () => Evergage.util.getValueFromNestedObject( "dataModelFields.field_departments", pageDetails, ) || null, JobRole: () => Evergage.util.getValueFromNestedObject( "dataModelFields.taxonomy_vocabulary_23", pageDetails, ) || null, PageBundle: () => { const pageBundle = Evergage.util.getValueFromNestedObject( "entityBundleNice", pageDetails, ); return pageBundle ? [pageBundle] : null; }, Keyword: Evergage.resolvers.fromMeta("keywords", (ele) => { return ele ? ele.split(/\,\s*/) : null; }), }, }, }, listeners: [ Evergage.listener( "submit", "#webform-submission-email-embeddable-1-add-form", (event) => { Evergage.sendEvent({ action: "Free Trial Download", /* A content zone is provided in this event in order to allow a campaign targeting the "global_infobar" content zone to be returned in the response sent back from Personalization with this request. */ source: { contentZones: ["global_infobar"], }, }); }, ), ], }, { name: "solutions", action: "Solutions", isMatch: () => { if ( /\/solutions\/(?!customers|industries|departments|technologies)/.test( window.location.pathname, ) ) { setPageDetailsFromDataLayer(); return true; } return false; }, catalog: { Article: { _id: () => Evergage.util.getValueFromNestedObject("entityId", pageDetails), name: () => Evergage.util.getValueFromNestedObject("entityLabel", pageDetails), url: Evergage.resolvers.fromCanonical(), imageUrl: Evergage.resolvers.fromSelectorAttribute( "div.feature-highlight__image img", "src", ), categories: Evergage.resolvers.fromWindow("location.pathname", (path) => { const categories = path.split("/").slice(1); categories.pop(); return [categories.join("|").toLowerCase()]; }), relatedCatalogObjects: { Industry: () => Evergage.util.getValueFromNestedObject( "dataModelFields.field_dmo_industries", pageDetails, ) || null, Department: () => Evergage.util.getValueFromNestedObject( "dataModelFields.field_departments", pageDetails, ) || null, JobRole: () => Evergage.util.getValueFromNestedObject( "dataModelFields.taxonomy_vocabulary_23", pageDetails, ) || null, PageBundle: () => { const pageBundle = Evergage.util.getValueFromNestedObject( "entityBundleNice", pageDetails, ); return pageBundle ? [pageBundle] : null; }, }, }, }, }, { name: "learning", action: "Learning", isMatch: () => { if (/^\/learn\//.test(window.location.pathname)) { setPageDetailsFromDataLayer(); return true; } return false; }, catalog: { Article: { _id: () => Evergage.util.getValueFromNestedObject("entityId", pageDetails), name: () => Evergage.util.getValueFromNestedObject("entityLabel", pageDetails), url: Evergage.resolvers.fromCanonical(), imageUrl: Evergage.resolvers.fromSelectorAttribute( "div.feature-highlight__image img", "src", ), categories: Evergage.resolvers.fromWindow("location.pathname", (path) => { const categories = path.split("/").slice(1); categories.pop(); return [categories.join("|").toLowerCase()]; }), relatedCatalogObjects: { Industry: () => Evergage.util.getValueFromNestedObject( "dataModelFields.field_dmo_industries", pageDetails, ) || null, Department: () => Evergage.util.getValueFromNestedObject( "dataModelFields.field_departments", pageDetails, ) || null, JobRole: () => Evergage.util.getValueFromNestedObject( "dataModelFields.taxonomy_vocabulary_23", pageDetails, ) || null, PageBundle: () => { const pageBundle = Evergage.util.getValueFromNestedObject( "entityBundleNice", pageDetails, ); return pageBundle ? [pageBundle] : null; }, }, }, }, }, { name: "blog", isMatch: () => { if (/\/about\/blog\/\d+\/\d+\/.+/.test(window.location.pathname)) { setPageDetailsFromDataLayer(); return true; } return false; }, catalog: { Blog: { _id: () => Evergage.util.getValueFromNestedObject("entityId", pageDetails), name: () => Evergage.util.getValueFromNestedObject("entityLabel", pageDetails), url: Evergage.resolvers.fromCanonical(), imageUrl: Evergage.resolvers.fromMeta("og:image"), categories: () => [ Evergage.util.getValueFromNestedObject("flatTaxonomy.blog_categories", pageDetails), ], }, }, listeners: [ Evergage.listener("submit", ".premium-access-ajax", () => { const eloquaId = findInDataLayer("EloquaGuid"); if (eloquaId) { Evergage.sendEvent({ action: "Tableau Blog Sign-up", user: { attributes: { eloquaId: eloquaId } }, }); } }), ], contentZones: [ /* As in this case below, content zones do not necessarily have to denote content to be replaced, they can be useful for inserting template content before or after the the DOM node with the provided selector. */ { name: "blog_text_content", selector: ".field--name-field-page-sections" }, ], }, ], }; Evergage.initSitemap(config); }); ``` ## See Also - [_Salesforce Help_: Identity System Setup for the Web SDK](https://help.salesforce.com/s/articleView?id=sf.mc_pers_identity_web_sdk.htm) # Best Practices for Data Capture Using Site Mapping After reviewing all relevant sitemap documentation, move your sitemap from your test dataset to your production environment only after thoroughly testing and validating it. Additionally, the information in this document can prove helpful to reference throughout each phase of implementation. As a final validation for working on a sitemap, we suggest working through the following steps. The checklists laid out in this document are by no means comprehensive. Instead, they call out common areas where implementors run into trouble while writing sitemap code. --- ## In this article - [Validate the JavaScript](#validate-the-javascript) - [Checklist](#checklist) - [Use the browser extension to test the sitemap code](#use-the-browser-extension-to-test-the-sitemap-code) - [Checklist](#checklist-1) - [sendEvent function usage](#sendevent-function-usage) - [Single Page App (SPA) sites](#single-page-app-spa-sites) - [Timing issues](#timing-issues) - [Data Capture Sources](#data-capture-sources) - [Window Objects](#window-objects) - [Meta Tags](#meta-tags) - [itemprop](#itemprop) - [JSON-LD](#json-ld) - [URLs](#urls) - [Page Source Code](#page-source-code) - [Example](#example) - [DisplayUtils](#displayutils) - [util.resolveWhenTrue](#utilresolvewhentrue) - [Additional Best Practices](#additional-best-practices) --- ## Validate the JavaScript ### Checklist - Check for common JavaScript errors by reviewing the sitemap code in the sitemap code editor, found in the Personalization Visual Editor. The sitemap code editor helps identify and highlight errors in your code. You can also validate your code by visually spot-checking it for errors. - Depending on your chosen SDK namespace, use `SalesforceInteractions.cashDom` or `Evergage.cashDom` for each implementation instead of using jQuery or another library that the Personalization platform does not include (such as Knockout). Since the Personalization Beacon includes CashDom (the [`cash`](https://github.com/fabiospampinato/cash#documentation) library), code written using CashDom remains unaffected by updates made to JS libraries found on the client site, thus allowing for greater stability over time. - Ensure that the sitemap does not manipulate the DOM in any way; that is the function of the Campaigns and Templates system. For more information on using these features on your Web integration, see [About Web Campaigns and Templates](https://help.salesforce.com/s/articleView?id=sf.mc_pers_web_campaign.htm) on Salesforce Help. - When using custom code to supply dates to the backend, ensure the custom code instantiates dates using `new Date(Date.UTC(YYYY, MM, DD))` instead of `new Date(YYYY, MM, DD)`. Using `new Date(YYYY, MM, DD)` can introduce errors due to differences between an end user's timezone and the way dates are stored as UTC. - Whenever possible, avoid using resolvers in situations where a direct value needs to be ingested since resolvers are designed to return a function. For example, the following examples depict improper use of a resolver. ```javascript var someValue = SalesforceInteractions.resolvers.fromSelector(".someCssSelector"); ``` ```javascript var someValue = Evergage.resolvers.fromSelector(".someCssSelector"); ``` ## Use the browser extension to test the sitemap code - Injecting or forcing the SDK URL to test the sitemap code. - [Install the Salesforce Interactions SDK Launcher](https://help.salesforce.com/s/articleView?id=sf.mc_pers_web_campaign_interactions_sdk_launcher.htm) - If you followed the best practices detailed in the [Plan a Web Integration](https://developer.salesforce.com/docs/marketing/personalization/guide/web-integration-planning.md) document, you can validate your sitemap code against an available test dataset. - After your test dataset runs on the site, click through the mapped pages and check to see that the events are sending as expected. - Refer to our documentation on [Event Validation Using Chrome Browser Developer Tools](https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-event-validation.md#event-validation-using-chrome-browser-developer-tools). ### Checklist - No errors in the **Network** tab for each event. - Mapped attributes are appearing as expected in the events. - Ensure that the [Sitemap Implementation](https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-implementation.md) and any [Event API Request](https://developer.salesforce.com/docs/marketing/personalization/event-api/event-options-salesforceinteractions.md) objects in your code are appropriately structured and collect values of the correct type for each option, as described in the documentation for [Attributes](https://developer.salesforce.com/docs/marketing/personalization/data-modeling/attributes.md). - When collecting `Category` data associated with another item type (`Article`, `Product`, or `Blog`), ensure that the structure and case of category IDs are _exactly_ consistent on all catalog items mapped with categories. - Carefully validate category ID structures. When mapping the `Category` item type directly, ensure that the value of `id` (or `_id` in the `Evergage` namespace) in the `pageType` is _always_ supplied as a string. Additionally, you can construct a hierarchy of Categories by using `|` separated values to denote each level of the `Category` hierarchy. Ideally, these values are normalized in some way with your sitemap as they are collected. Normalizing these values helps ensure consistency within your catalog. For example, the Personalization platform considers a `Category` with a "Green Hats" ID different from a Category with a "Green hats" ID. In the following example `Category` ID, all the principles and best practices concerning `Category ID` structure have been used: `main-category|sub-cat-1|sub-cat-2`. - Check whether listeners are binding correctly on each page and are successfully sending events without errors or incorrectly formatted data. For example, if a sitemap has a click listener that listens for a button click to send an `AddToCart` event, ensure that clicking that button sends an `AddToCart` event with all the appropriate `lineItem` data successfully. - Validate that `onActionEvent` is being used correctly. While it is possible, we strongly discourage the use of event listeners and/or the `sendEvent` function in `onActionEvent`. However, if you do decide that you must use `sendEvent` here, take extra care to make sure that your code includes an exit case. Otherwise, you risk the possibility of triggering an infinite loop. Ensure that `onActionEvent` is not being used to overwrite the contents of the event, instead only to manipulate it and/or append additional data. Additionally, make sure that `onActionEvent` always returns the `ActionEvent`, even if no transformations and/or modifications are made. You can find examples of properly using `onActionEvent` to ingest user attributes in the [Capturing User and Account Attributes](https://developer.salesforce.com/docs/marketing/personalization/guide/capturing-user-account-attributes.md) page. - Validate that your code is using supported and correctly formatted fields when mapping Page Types. The supported fields are outlined in the [Page Types](https://developer.salesforce.com/docs/marketing/personalization/guide/page-types.md) documentation. - Ensure that your mapped content zones can serve the customer's use-cases. Refer to the [Content Zones documentation that outlines many commonly mapped content zones to get some ideas. ## sendEvent function usage Depending on the SDK namespace you use, the following `sendEvent` function is used to send an Event to Personalization. Ensure that events sent using this function strictly follow the structure of the Event API requests, as outlined in the [Event API](https://developer.salesforce.com/docs/marketing/personalization/event-api/event-api.md) documentation. ```javascript SalesforceInteractions.sendEvent; ``` ```javascript Evergage.sendEvent; ``` **note:** While very similar, the Event API and page types in the sitemap _do_ have different structures. ## Single Page App (SPA) sites For more information about handling SPA page changes, refer to the [Single Page App (SPA) Handling](https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-implementation.md#single-page-app-spa-handling) documentation. While using an interval powers the documented example on that page, you can use a different mechanism to monitor the site for page changes at your discretion. ## Timing issues - Do selectors work in the console or editor, but the sitemap is still unsuccessful in scraping those values when sending the event? - The location of the data you are scraping probably does not exist at the time the page matches. - Solution: - Write a [`Promise`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise) for the `isMatch` function that matches the page type, which relies on data not available precisely at page load. The page is matched after the `Promise` resolves, that resolution being delayed until the source of your data exists in the DOM or `window` object. **note:** If you do decide to use a Promise, ensure that you include a mechanism that resolves the Promise after a set period, regardless of whether the match condition has been met. - Does the catalog configuration work in the editor, but the sitemap is still unsuccessful in scraping those values when sending the event? - The catalog configuration values are being evaluated when the sitemap is parsed and not when the `pageType` is matched. - Solution: - Be sure to use custom functions or [`resolvers`](https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-implementation.md#resolvers) for catalog configuration values. If you do not use functions or resolvers, these fields are evaluated when the browser parses the sitemap object, not when the `pageType` is evaluated. - For example: ```javascript description: () => window.product.description; ``` ## Data Capture Sources When deciding on what to capture, first **consider all possible locations where the data is available on the page for that `pageType`**. While testing a new data source, ensure that the method of obtaining the data persists throughout the Page Type and that the data is available when the sitemap executes. For synchronous integrations, this could mean using a `Promise` to resolve the `isMatch` function when data is available or using `Promises` for the catalog ID field until the available data is available to capture. ### Window Objects Data found within window objects (that is, `window.dataLayer`) tends to be more static and reliable, though be careful about using a third-party vendor. Sites correctly implemented with Shopify, Magento, and Drupal tend to be more reliable than others. Taken from the [ecommerce example](https://developer.salesforce.com/docs/marketing/personalization/guide/example-sitemaps/ecommerce.md), we are able to extract the product details found inside the ecommerce data object in the following examples. ```javascript const getProductsFromDataLayer = () => { if (window.dataLayer) { for (let i = 0; i < window.dataLayer.length; i++) { if ( ((window.dataLayer[i].ecommerce && window.dataLayer[i].ecommerce.detail) || {}).products ) { return window.dataLayer[i].ecommerce.detail.products; } } } }; ``` ```javascript const getProductsFromDataLayer = () => { if (window.dataLayer) { for (let i = 0; i < window.dataLayer.length; i++) { if ( ((window.dataLayer[i].ecommerce && window.dataLayer[i].ecommerce.detail) || {}).products ) { return window.dataLayer[i].ecommerce.detail.products; } } } }; ``` You can use the `SalesforceInteractions.resolvers.fromWindow` and `SalesforceInteractions.mcis.getValueFromNestedObject` functions in the `SalesforceInteractions` namespace and `Evergage.resolvers.fromWindow` and `Evergage.util.getValueFromNestedObject` functions in the `Evergage` namespace to return a value from a nested object safely. For example, when capturing data from `window.dataLayer[0].ecommerce.detail.products`, you could encounter an error if one part of the path is not defined. The `SalesforceInteractions.resolvers.fromWindow` function ( the `Evergage.resolvers.fromWindow` function in the `Evergage` namespace) safely navigates the given path to return a value if it exists or `null` if the nested object, or some object in the path, does not exist. ### Meta Tags If the data exists within the meta tag and the DOM, meta tag data is a reliable data format. Personalization has a built-in resolver function in the `SalesforceInteractions` and `Evergage` namespaces to retrieve data from meta tags: ```javascript SalesforceInteractions.resolvers.fromMeta(); ``` ```javascript Evergage.resolvers.fromMeta(); ``` As an example, say a hypothetical website selling widgets contains the following meta tag for description. ```html ``` In a catalog configuration, you can retrieve the description content of that tag with the following code. ```javascript description: SalesforceInteractions.resolvers.fromMeta("description"); ``` ```javascript description: Evergage.resolvers.fromMeta("description"); ``` `description` now has the string value: `The premier place for all your widget needs.` ### itemprop The `itemprop` attribute is used to add properties to an element on the page, describing the content in the element. To learn more about the itemprop attribute, refer to the [itemprop](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/itemprop) documentation on the [Mozilla Developer Network](https://developer.mozilla.org/en-US/). Depending on the SDK namespace you're using, Personalization has the following built-in resolver function to retrieve data from elements with a specified `itemprop`. This resolver function returns the content of the first matching element with the given `itemprop`. ```javascript SalesforceInteractions.resolvers.fromItemProp; ``` ```javascript Evergage.resolvers.fromItemProp; ``` For example, when trying to capture the rating on a product, you could come across a page that contains the following element: ```html ``` In a catalog configuration, you can retrieve the rating value of that element with the following code. ```javascript rating: SalesforceInteractions.resolvers.fromItemProp("ratingValue"); ``` ```javascript rating: Evergage.resolvers.fromItemProp("ratingValue"); ``` `rating` now has the value `"5"` ### JSON-LD JSON-LD is a popular way to annotate and describe elements on a page with structured data. Personalization has the following built-in resolver function to parse and retrieve data from a JSON-LD element. This resolver function parses the first JSON-LD script on the page. If given a `path`, it returns the value of the path from the parsed JSON-LD object. ```javascript SalesforceInteractions.resolvers.fromJsonLd; ``` ```javascript Evergage.resolvers.fromJsonLd; ``` For example, if a site had the following element: ```html ``` In the catalog configuration, you can retrieve the entire object using the preceding resolver function. Alternatively, if you only wanted a single element such as `name`, use the resolver function as shown in the following examples to retrieve the entire object. ```javascript SalesforceInteractions.resolvers.fromJsonLd("name"); ``` ```javascript Evergage.resolvers.fromJsonLd("name"); ``` ### URLs A page's URL can contain helpful information that you'd like to capture. For example, you can capture a Product URL directly from the URL the user is visiting using the following resolver function. ```javascript SalesforceInteractions.resolvers.fromHref; ``` ```javascript Evergage.resolvers.fromHref; ``` Some pages can also contain a canonical link element that is the preferred URL of the page. You can capture canonical URLs using the following resolver function. ```javascript SalesforceInteractions.resolvers.fromCanonical; ``` ```javascript SalesforceInteractions.resolvers.fromCanonical; ``` ### Page Source Code Sometimes the only source of data is the DOM itself. Personalization has several helper functions that can extract the data you need. The following table lists the helper functions available in the `SalesforceInteractions` and `Evergage` SDK namespaces that you can use to extract text and attributes from elements in the DOM. | `SalesforceInteractions` | `Evergage` | Description | | ---------------------------------------------------------------- | -------------------------------------------------- | ------------------------------------------- | | `SalesforceInteractions.resolvers.fromSelector` | `Evergage.resolvers.fromSelector` | Retrieve data from an element. | | `SalesforceInteractions.resolvers.fromSelectorMultiple` | `Evergage.resolvers.fromSelectorMultiple` | Retrieve data from multiple elements. | | `SalesforceInteractions.resolvers.fromSelectorAttribute` | `Evergage.resolvers.fromSelectorAttribute` | Retrieve attributes from an element. | | `SalesforceInteractions.resolvers.fromSelectorAttributeMultiple` | `Evergage.resolvers.fromSelectorAttributeMultiple` | Retrieve attributes from multiple elements. | #### Example Consider your website's sitemap code has the following element. ```html Worlds Greatest Widget ``` In the catalog configuration, you can retrieve the product ID with the following code. ```javascript id: SalesforceInteractions.resolvers.fromSelectorAttribute("#product", "data-productId"); ``` ```javascript _id: Evergage.resolvers.fromSelectorAttribute("#product", "data-productId"); ``` You can also retrieve the product's name with the following code. ```javascript name: SalesforceInteractions.resolvers.fromSelector("#product"); ``` ```javascript name: Evergage.resolvers.fromSelector("#product"); ``` If you're familiar with [cash](https://kenwheeler.github.io/cash/), you can use `SalesforceInteractions.cashDom` (or `Evergage.cashDom` in the `Evergage` namespace) to retrieve data on the DOM. You can view the list of available utility functions in Evergage.js in the source menu inside the dev tool. ### DisplayUtils When you do have to use a Promise to wait for data to be available, the [web template display utilities](https://developer.salesforce.com/docs/marketing/personalization/campaign-development/web-campaigns-templates/web-template-display-utilities.md) provide methods that are helpful in waiting for specific elements to be on the page. These methods trigger only when the specified element is loaded on the page. For example, if you need to wait for the `#productId` element to be on the page in order to capture the ID of a product, you can use `pageElementLoaded` utility as shown in the following examples. ```javascript id: () => { return SalesforceInteractions.DisplayUtil.pageElementLoaded("#productId", "html").then( (ele) => { return SalesforceInteractions.resolvers.fromSelector("#productId"); }, ); }; ``` ```javascript _id: () => { return Evergage.DisplayUtil.pageElementLoaded("#productId", "html").then((ele) => { return Evergage.resolvers.fromSelector("#productId"); }); }; ``` ### util.resolveWhenTrue When you have to wait for data to be available on the page, you can use the following [utility function](https://developer.salesforce.com/docs/marketing/personalization/guide/sitemap-implementation.md#utility-functions) to bind and unbind processes that return a Promise that resolves when the provided function returns a "truthy" value. ```javascript SalesforceInteractions.util.resolveWhenTrue; ``` ```javascript Evergage.util.resolveWhenTrue; ``` The preceding function also supports a timeout that rejects the Promise if the provided function does not return a "truthy" value within the specified time. For example, if you need to wait for the `window.dataLayer[0].productId` to be available on the page to capture the product ID, you can use the following code. ```javascript id: () => { return SalesforceInteractions.util.resolveWhenTrue.bind(() => { let productId = SalesforceInteractions.mcis.getValueFromNestedObject( "window.dataLayer[0].productId", ); if (productId) { return productId; } else { return false; } }, undefined, 1000, 50); }; ``` ```javascript _id: () => { return Evergage.util.resolveWhenTrue.bind(() => { let productId = Evergage.util.getValueFromNestedObject("window.dataLayer[0].productId"); if (productId) { return productId; } else { return false; } }, undefined, 1000, 50); }; ``` ### Additional Best Practices - **Avoid undefined data** - If your data field depends on a resolver, include it as a return inside a function to avoid sending undefined data. - **Practice console logging** - Get into a good habit of console logging the data in the sitemap. Just be
[...]
